/* ilib.h */
/*********************************************************************
 This is the client's #include file for accessing functions in ilib.a
 Istvan Mohos, 1987
**********************************************************************/

/* functions archived in ilib.a: */
char * ialntok();
char * ianytok();
int    ibcmp();
void   ibcopy();
void   iblank();
int    ibreakl();
char * ictok();
char * icopy();
int    icount();
void   icue();
int    idamage();
char * idate();
void   idump();
int    iego();
int    ierror();
int    iexpect();
int    ifamily();
int    ifilter();
int    igroup();
int    ihash();
int    ihasharg();
char * ihms();
int    iinput();
char * ilast();
int    iline();
int    ilist();
int    ilistn();
int    illistn();
int    ilongest();
int    ilower();
char * imatch();
int    imode();
int    imonth();
int    imung();
int    inest();
char * inl();
char * inull();
int    inumsearch();
void   inumsort();
int    inumstrcmp();
char * inextl();
int    iopt();
int    iread();
int    irotate();
int    iround();
int    isearch();
void   isort();
char * istartl();
int    istripcom();
int    istripdq();
int    istripsq();
int    istripstr();
int    itexrect();
int    itoday();
int    itohour();
int    itok();
int    itomin();
int    itomonth();
int    itosec();
int    itoyear();
int    itran();
void   itwin();
int    iuniq();
int    iuniqa();
int    iupper();
char * iwhich();
int    iwrite();
int    iwritopn();
char * ixmatch();
int    ixmung();
int    ixsearch();

char * malloc();
char * calloc();
long   lseek();

#include <stdio.h>
#ifndef X_OK
#    ifdef REALUNIX
#        define F_OK 0
#        define X_OK 1
#        define W_OK 2
#        define R_OK 4
#        include <fcntl.h>
#    else
#        include <sys/file.h>
#    endif
#endif

extern char ierbuf[];
extern int  ierflag;

#define INITOKF       1    /* setup forward parsing */
#define INITOKR      -1    /* setup reverse parsing */
#define ITOKF         2    /* forward parse */
#define ITOKR        -2    /* reverse parse */

#define DOUNCOUN(x,y) (y) = (x); --(y) >= 0
#define BADCHARP(p)   ((p) == (char *)NULL || *(p) == '\0')
#define NULCHARP(p)   ((p) == (char *)NULL)
#define ZPT           (char *)NULL

#define IANYTOK       0
#define IALNTOK       1
#define ICTOK         2

#define SPACE_LINE   -1
#define LINE_ONLY     0
#define LINE_SPACE    1

#define IROTR         1 /* rotate 90 deg. to right */
#define IROTL        -1 /* rotate 90 deg. to left */
#define IROTOR        3 /* rotate 180 deg. over and 90 deg. to right */
#define IROTOL       -3 /* rotate 180 deg. over and 90 deg. to left */

#define SHORTMO       0 /* idate format: Jun 23 1988 */
#define SHORTUPMO     1 /* idate format: JUN 23 1988 */
#define LONGMO        2 /* idate format: June 23, 1988 */
#define LONGUPMO      3 /* idate format: JUNE 23, 1988 */

#define WHITE(c)      ((c) < 33)
#define BLACK(c)      ((c) > 32)
#define TONEXWHITE(p) while (*(p) && (*(p)>32)) (p)++
#define TONEXBLACK(p) while (*(p) && (*(p)<33)) (p)++

#define IFOURK        4096
#define ITWOK         2048
#define IONEK         1024
#define IHALFK        512
#define IQUARTK       256
